#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include "db.h"
#include "itemset.h"
#include "ver0.h"
#include "mpi.h"

/* 
 * This is the first version of association mining
 * which reads data from a database input file
 * and stores the data in the defined structure array.
 *
 * The program assumes the format of the input file
 * is correct.
 */
main( int argc, char * argv[] )
{
  char fName[20];
  FILE *inFp;
  DBASE * db;
  MINITEMS * minList;

  /* variables used in MPI */
  int myId, pNum;
  MPI_Status status;

  /* setup the environment */
  MPI_Init( &argc, &argv );
  MPI_Comm_size( MPI_COMM_WORLD, &pNum );
  MPI_Comm_rank( MPI_COMM_WORLD, &myId );

  if( myId=0 ) {
    printf( "**************************************** \n" );
    printf( "Qiang Zheng's association mining program \n" );
    printf( "Please specify input data file name: \n" );
    scanf( "%s", fName );

    strcpy( fName,"input" );

    inFp = fopen(fName, "r");

    if ( inFp == NULL ) {
      printf( "Cannot open file %s\n", fName );
      return 1;
    }

    /* read from file */
    db = readFrom( inFp ); 
  }

  MPI_Bcast();

  /* associatMining(); */
  /* report( db );
   */

  minList = newMinItSetList( db );

  showRelat( minList );

  delMinItemSetList( minList );

  /* house cleaning */
  delDb( db );
  fclose( inFp );
  /* MPI_Finalize(); */
}
